"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var path = require("path");
var expect = require("chai").expect;
var rollup = require("rollup").rollup;
var terser = require("rollup-plugin-terser").terser;
var bundleInject = require("../dist/rollup-plugin-bundle-inject.cjs.js");
var getOutputFromGenerated = require("./helper/utils").getOutputFromGenerated;
var input = "main.js";
var htmlPath = path.resolve(__dirname, "./fixtures/default.html");
var htmlFileName = path.basename(htmlPath);
var jsCode = "const a = 1; const b = 2; function sum(a, b) { return a + b; }; console.log(sum(a, b));";
describe("test: default", function () {
    it("css bundle should be injected into the end of the <head> tag by default", function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2 /*return*/];
    }); }); });
    it("js bundle should be injected into the end of the <body> tag by default", function () { return __awaiter(void 0, void 0, void 0, function () {
        var bundle, generated, output, bundleCode, htmlSource, i;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, rollup({
                        input: input,
                        plugins: [
                            bundleInject({
                                target: htmlPath,
                            }),
                            terser(),
                            {
                                name: "fake-plugin",
                                resolveId: function (id) {
                                    return id;
                                },
                                load: function (importee) {
                                    if (importee === "main.js")
                                        return jsCode;
                                },
                            },
                        ],
                    })];
                case 1:
                    bundle = _a.sent();
                    return [4 /*yield*/, bundle.generate({ format: "es" })];
                case 2:
                    generated = _a.sent();
                    output = generated.output;
                    console.log(222, output);
                    for (i = 0; i < output.length; i++) {
                        if (output[i].fileName === input) {
                            bundleCode = output[i].code;
                        }
                        else if (output[i].fileName === htmlFileName) {
                            htmlSource = output[i].source;
                        }
                    }
                    expect(htmlSource).to.include("<script>" + bundleCode + "</script>");
                    return [2 /*return*/];
            }
        });
    }); });
});
